#include<stdlib.h>
#include<stdio.h>
#include<asm/page.h>

#define MSIZE 1024*1024*8
#define MERGEABLE 23423423

void err_exit( char *t )
{
  printf( "%s\n", t );
  exit( 1 );
}

main()
{
  long* mem;
  char w;
  int i;
  int cont=1;
  int beg,end;
  int nonMergeAble;
  
  nonMergeAble=getpid();
  
  printf("Press [ENTER] to allocate %d KB (%d Pages)\n",MSIZE/1024,MSIZE/PAGE_SIZE);
  getchar();
  
  mem = (long* )malloc((size_t)MSIZE);
  if(mem == 0) err_exit("malloc() failed\n");

  while(cont)
    {
      do
	{
	  printf("i,q; i=initialize mem, q=quit\n>");
	  w=getchar();
	}
      while(w != 'i' && w !='q');
      
      switch(w)
	{
	 case 'i': 
	  #if 0
	  printf("Enter number of first page of mergable pattern (0-%d)",MSIZE/PAGE_SIZE);
	  scanf("%i",&beg);
	  printf("Enter number of last page of mergable pattern (%d-%d)",beg+1,MSIZE/PAGE_SIZE);
	  scanf("%i",&end);
	  #else
	  beg=0;   
	  end=MSIZE/PAGE_SIZE;
	  #endif
	  for(i=0;i<beg*PAGE_SIZE/sizeof(long);i++) mem[i]=nonMergeAble; 
	  for(;i<end*PAGE_SIZE/sizeof(long);i++) mem[i]=MERGEABLE; 
	  for(;i<MSIZE/sizeof(long);i++) mem[i]=nonMergeAble; 
	  
	  break;
	 case 'q': cont=0; break;
	}
      getchar();
    } /* while(cont) */
} /* main */

  
  
  
